-- Homing attack players script

addHook("ThinkFrame", do
	for player in players.iterate
		if player.mo
			
			if not player.mo.doattack
				player.mo.doattack = 0
			end
			
			if player.mo.doattack >= 1
				if player.mo.target.player
				and not P_PlayerInPain(player.mo.target.player) --Check invincibility timer for spawning or after being hit to prevent conflicts
				and not player.mo.target.player.powers[pw_flashing] --Not flashing (inv-timer)
				and not (player.mo.state==S_PLAY_DIE)
				and (player.pflags & PF_JUMPED)
					P_HomingAttack(player.mo, player.mo.target) -- Homing attack the other player
					player.mo.doattack = $1 - 1
					--P_InstaThrust(player.mo, R_PointToAngle2(player.mo.x, player.mo.y, player.mo.target.x, player.mo.target.y), max(R_PointToDist2(player.mo.x, player.mo.y, player.mo.target.x, player.mo.target.y), 32*FRACUNIT))
					--P_SetObjectMomZ(player.mo, (player.mo.target.z - player.mo.z)/2, false)
					--P_SpawnThokMobj(player)
				else
					player.mo.doattack = 0
				end
			end
			
		end
	end
end)

addHook("AbilitySpecial", function(player)
	if player.charability == CA_THOK
	or player.charability == CA_HOMINGTHOK
	or player.charability == CA_JUMPTHOK
		if P_SupermanLook4Players(player.mo)
			if player.mo.z >= player.mo.target.z --check height above
			and abs(player.mo.x - player.mo.target.x)<400*FRACUNIT
			and abs(player.mo.y - player.mo.target.y)<400*FRACUNIT
			and not (player.mo.target == player.mo) --Make sure the actor is not found.
			and not (player.pflags & PF_THOKKED) -- Hasn't thokked yet
			and abs(player.mo.target.z - player.mo.z)<400*FRACUNIT --Distance on the Z Axis
			and not P_PlayerInPain(player.mo.target.player) --Check invincibility timer for spawning or after being hit to prevent conflicts
			and not ((gametype == GT_TEAMMATCH or gametype == GT_CTF) and player.mo.target.color == player.mo.color) --Not on same team in ringslinger gametypes
				player.mo.doattack = 3*TICRATE
			end
		end
	end
end)